grammar ilpRules;

// export to /Users/drizo/cmg/investigacion/software/imjava/imtonalanalysis2/src/es/ua/dlsi/im2/tonalanalysis/academic/antlr
// set classpath in preferences for debug to /Users/drizo/cmg/investigacion/software/imjava/imtonalanalysis2/src/
@lexer::header {
package es.ua.dlsi.im2.tonalanalysis.academic.antlr;

}

@lexer::members {
  public void emitErrorMessage(String msg) {
    //throw new RuntimeException(msg);
    //throw Exception(re);
  }
}

@parser::header {
package es.ua.dlsi.im2.tonalanalysis.academic.antlr;
import java.util.ArrayList;
import java.util.Hashtable;

import es.ua.dlsi.im2.tonalanalysis.academic.scoreanalysiskinds.MelodicAnalysisNoteKinds;
import es.ua.dlsi.im2.tonalanalysis.academic.MelodicAnalysisException;
}

@parser::members {
  public void emitErrorMessage(String msg) {
    //throw new RuntimeException(msg);
//    System.exit(1); 
//	throw Exception(re);
  }  
  int ruleNumber=1;
}

@rulecatch { 
   catch (RecognitionException re) { 
     //reportError(re); 
//     throw Exception(re);
    //System.exit(1); 
  } 
}

rules	  returns [StringBuilder output]
	@init {
		$output = new StringBuilder();
	}
:	
	(rule {$output.append($rule.output);}) *;

rule returns [StringBuilder output]	
	@init {
		$output = new StringBuilder();
		String ruleName = "r" + ruleNumber;
		int salience = -ruleNumber;
		$output.append("rule \"" + ruleName + "\"\n"); 
		$output.append("\tsalience " + salience + "\n");
		ruleNumber++;
		$output.append("\twhen\n");
		StringBuilder sba = new StringBuilder("C: NoteMelodicAnalysisDecorationForILP();\n"); // for empty rules
		String ilpRule = "default"; 
	}
	:	
	consequent (':-' (antecedents {sba = new StringBuilder(); sba.append($antecedents.output); ilpRule = $antecedents.ILP; })? DOT) 
	{
		//$output.append("\tC: NoteMelodicAnalysisDecorationForILP(");
		$output.append(sba.toString());
		//$output.append(");\n");
		$output.append("\tthen\n");
		$output.append("\t\tC.addMelodicAnalysis(MelodicAnalyzerILP.getRunningAnalyzer(), ");
		$output.append("\""+ruleName + ": " + ilpRule.replaceAll("\"","") + "\""); // quote to escape tring
		$output.append(",MelodicAnalysisNoteKinds.");
		$output.append($consequent.tagValue); 
		$output.append(", Confidence.INDETERMINATE, " + salience +");\n\n");
		$output.append("end\n");
	}
	;
consequent returns [MelodicAnalysisNoteKinds tagValue]
	:		
	ID '(' ID ( ',' ID )* ',' tag {$tagValue = $tag.output;} ')';
	
antecedents returns [StringBuilder output, String ILP]
	@init {
		Hashtable<String, ArrayList<String> > objectsAntecedents = new Hashtable<String, ArrayList<String>>();
		StringBuilder objectsILPRules = new StringBuilder();
		$output = new StringBuilder();
	}
	:
	(antecedent 
		{
			ArrayList<String> v = objectsAntecedents.get($antecedent.object);
			if (v == null) {
				v = new ArrayList<String>();
				objectsAntecedents.put($antecedent.object, v);
			}
			v.add($antecedent.output);
			if (objectsILPRules.length() > 0) {
				objectsILPRules.append(", ");
			}
			objectsILPRules.append($antecedent.ruleILP);
		}
		','
	)+ EXCL
	{
		for (String obj: objectsAntecedents.keySet()) {	
			$output.append('\t');
			$output.append('\t');
			$output.append(obj);
			$output.append(": NoteMelodicAnalysisDecorationForILP(");
			ArrayList<String> v = objectsAntecedents.get(obj);
			for (int ii=0; ii<v.size(); ii++) {
				if (ii > 0) {
					$output.append(',');
				}
				$output.append(v.get(ii));	
			}			
			$output.append(");\n");
		} 
		$ILP = objectsILPRules.toString();
	} 
	;	
antecedent returns [String object, String output, String ruleILP]
	@init {
		String featureValue="";
	}
	:		
	featureName=ID '(' fvA=ID ',' fvB=ID ',' fvObject=ID {$object = $fvObject.text;} ',' val=value
	{
		if ($featureName.text.equals("pred") || $featureName.text.equals("succ")) {
			$output = $featureName.text + "==" + $val.output.replace('\"', ' '); 
		} else {
			$output = $featureName.text + "==" + $val.output; 
		}	
		$ruleILP = $featureName.text + "(" + $fvObject.text + "," + $val.output + ")";
	}
	;
	
value	returns [String output]
	:
	ID {$output = "\"" + $ID.text + "\"";} 
	| INT {$output = $INT.text;} 
	| FLOAT {$output = $FLOAT.text;} 
	| BOOLEAN {$output = $BOOLEAN.text; }
	;	
	
tag	returns [MelodicAnalysisNoteKinds output]
	: 
	'[' ID 
	{
		try {
			$output = MelodicAnalysisNoteKinds.abbrToMelodicAnalysis($ID.text);
		} catch (MelodicAnalysisException e) {
			e.printStackTrace();
			$output = MelodicAnalysisNoteKinds.NONE;
		}
	} 
	']';		

BOOLEAN
	:
	'true' |�'false';    

ID  :	('a'..'z'|'A'..'Z'|'_') ('a'..'z'|'A'..'Z'|'0'..'9'|'_')*
    ;

INT :	'0'..'9'+
    ;

FLOAT
    :   ('0'..'9')+ '.' ('0'..'9')* 
    |   '.' ('0'..'9')+ 
    ;
    
EXCL	:	'!';
DOT	:	'.';

COMMENT
    :   '%' ~('\n'|'\r')* '\r'? '\n' {$channel=HIDDEN;}
    ;

//NEWLINE	:	('\r'? '\n'|' '|'\t')+ {skip();} ;
