grammar romananalysisvalue;

// export to /Users/drizo/cmg/investigacion/software/imjava/imtonalanalysis2/src/es/ua/dlsi/im2/tonalanalysis/academic/antlr
// set classpath in preferences for debug to /Users/drizo/cmg/investigacion/software/imjava/imtonalanalysis2/src/
@lexer::header {
package es.ua.dlsi.im2.tonalanalysis.academic.antlr;

}

@lexer::members {
  public void emitErrorMessage(String msg) {
    //throw new RuntimeException(msg);
    //throw Exception(re);
  }
}

@parser::header {
package es.ua.dlsi.im2.tonalanalysis.academic.antlr;

import es.ua.dlsi.im2.model.*;
import java.util.List;
import java.util.ArrayList;
import es.ua.dlsi.im2.tonalanalysis.RomanAnalysisValue;
}

@parser::members {
  public void emitErrorMessage(String msg) {
    //throw new RuntimeException(msg);
//    System.exit(1); 
//	throw Exception(re);
  }
}

@rulecatch { 
   catch (RecognitionException re) { 
     //reportError(re); 
//     throw Exception(re);
    //System.exit(1); 
  } 
}

basedegree returns [RomanAnalysisValue value]
	@init {
		$value = new RomanAnalysisValue();
	}
	:
	(
	MAJORDEGREES {$value.setDegree($MAJORDEGREES.text); $value.setMode(IntervalMode.MAJOR);} 
		(
		O  
		|
		B 
		)?
	|
	MINORDEGREES {$value.setDegree($MINORDEGREES.text); $value.setMode(IntervalMode.MINOR);}
	)
	(SEVENTH {$value.setSeventh(true);})?
	SEMICOLON?
	;
	
degree	returns [RomanAnalysisValue value]
	:
	deg=basedegree {$value = $deg.value; } (SLASH ext=basedegree {$value.setInversion($ext.value);})?
	;

O	:	'o';	// tonic missing TODO

B	:	'b'; // first inversion TODO

SEMICOLON :	';'; // harmonic breaks TODO
	
SEVENTH	:	'7';

LOWERED	:	'-'; // lowered chord TODO


MINORDEGREES
	:	
	('i' | 'ii' | 'iii' | 'iv' | 'v' | 'vi' | 'vii');

MAJORDEGREES	

	:	
	('I' | 'II' | 'III' | 'IV' | 'V' | 'VI' | 'VII');

SLASH	:	'/';


